const LEVELS = [
    {
        environment: {
            path: '/',
            files: [
                { filename: 'Videos', data: [
                    { filename: 'trailer.ogv', type: 'video/ogg', data: 'Videos/trailer.ogv' },
                    { filename: 'Schulprojekt', data: [
                        { filename: 'ideenskizze.txt', type: 'text/plain', data: 'Videos/Schulprojekt/ideenskizze.txt' },
                        { filename: 'aufnahme1.mp4', type: 'video/mp4', data: 'Videos/Schulprojekt/aufnahme1.mp4' }
                    ] },
                    { filename: 'trailer', data: [
                        { filename: 'agent327.ogv', type: 'video/ogg', data: 'Videos/trailer/agent327.ogv' }
                    ] },
                    { filename: 'big_buck_bunny.ogv', type: 'video/ogg', data: 'Videos/big_buck_bunny.ogv' },
                    { filename: 'caminandes', data: [
                        { filename: '1_llama-drama.ogv', type: 'video/ogg', data: 'Videos/caminandes/1_llama-drama.ogv' },
                        { filename: '2_gran-dillama.ogv', type: 'video/ogg', data: 'Videos/caminandes/2_gran-dillama.ogv' },
                        { filename: '3_llamigos.ogv', type: 'video/ogg', data: 'Videos/caminandes/3_llamigos.ogv' },
                        { filename: '1_llama-drama.png', type: 'image/png', data: 'Videos/caminandes/1_llama-drama.png' },
                        { filename: '2_gran-dillama.png', type: 'image/png', data: 'Videos/caminandes/2_gran-dillama.png' },
                        { filename: '3_llamigos.png', type: 'image/png', data: 'Videos/caminandes/3_llamigos.png' }
                    ] },
                    { filename: 'uebersicht.ods', type: 'application/vnd.oasis.opendocument.spreadsheet', data: 'Videos/uebersicht.ods' }
                ] },
                { filename: 'backups', data: [
                    { filename: 'gescheitert', data: [] }
                ] }
            ]
        },
        html: 'Auch in dieser Simulation kannst du die Zwischenablage verwenden. Nutze sie, um im Wurzelordner eine Datei mit dem Namen <code>∞_viele_½Sachen…</code> zu erstellen: Kopiere den Dateinamen in die Zwischenablage und fügen ihn dann beim Erstellen der neuen Datei in das zugehörige Eingabefeld ein.',
        onchange() {
            var file = this._root.getByPath('/∞_viele_½Sachen…');
            return (file && !file.isDir);
        }
    },
    {
        environment: {
            path: '/',
            files: [
                { filename: 'Videos', data: [
                    { filename: 'trailer.ogv', type: 'video/ogg', data: 'Videos/trailer.ogv' },
                    { filename: 'Schulprojekt', data: [
                        { filename: 'ideenskizze.txt', type: 'text/plain', data: 'Videos/Schulprojekt/ideenskizze.txt' },
                        { filename: 'aufnahme1.mp4', type: 'video/mp4', data: 'Videos/Schulprojekt/aufnahme1.mp4' }
                    ] },
                    { filename: 'trailer', data: [
                        { filename: 'agent327.ogv', type: 'video/ogg', data: 'Videos/trailer/agent327.ogv' }
                    ] },
                    { filename: 'big_buck_bunny.ogv', type: 'video/ogg', data: 'Videos/big_buck_bunny.ogv' },
                    { filename: 'caminandes', data: [
                        { filename: '1_llama-drama.ogv', type: 'video/ogg', data: 'Videos/caminandes/1_llama-drama.ogv' },
                        { filename: '2_gran-dillama.ogv', type: 'video/ogg', data: 'Videos/caminandes/2_gran-dillama.ogv' },
                        { filename: '3_llamigos.ogv', type: 'video/ogg', data: 'Videos/caminandes/3_llamigos.ogv' },
                        { filename: '1_llama-drama.png', type: 'image/png', data: 'Videos/caminandes/1_llama-drama.png' },
                        { filename: '2_gran-dillama.png', type: 'image/png', data: 'Videos/caminandes/2_gran-dillama.png' },
                        { filename: '3_llamigos.png', type: 'image/png', data: 'Videos/caminandes/3_llamigos.png' }
                    ] },
                    { filename: 'uebersicht.ods', type: 'application/vnd.oasis.opendocument.spreadsheet', data: 'Videos/uebersicht.ods' }
                ] },
                { filename: 'backups', data: [
                    { filename: 'gescheitert', data: [] }
                ] },
                { filename: '∞_viele_½Sachen…', data: '∞_viele_½Sachen…' }
            ]
        },
        html: 'Die Zwischenablage kann auch Dateien enthalten: Kopiere die Datei <code>/Videos/trailer.ogv</code> in die Zwischenablage.',
        onchange() {
            return (this.clipboard && (this.clipboard.data == 'Videos/trailer.ogv') && !this.boolMove);
        }
    },
    {
        environment: {
            path: '/Videos',
            clipboard: { move: false, path: '/Videos/trailer.ogv' },
            files: [
                { filename: 'Videos', data: [
                    { filename: 'trailer.ogv', type: 'video/ogg', data: 'Videos/trailer.ogv' },
                    { filename: 'Schulprojekt', data: [
                        { filename: 'ideenskizze.txt', type: 'text/plain', data: 'Videos/Schulprojekt/ideenskizze.txt' },
                        { filename: 'aufnahme1.mp4', type: 'video/mp4', data: 'Videos/Schulprojekt/aufnahme1.mp4' }
                    ] },
                    { filename: 'trailer', data: [
                        { filename: 'agent327.ogv', type: 'video/ogg', data: 'Videos/trailer/agent327.ogv' }
                    ] },
                    { filename: 'big_buck_bunny.ogv', type: 'video/ogg', data: 'Videos/big_buck_bunny.ogv' },
                    { filename: 'caminandes', data: [
                        { filename: '1_llama-drama.ogv', type: 'video/ogg', data: 'Videos/caminandes/1_llama-drama.ogv' },
                        { filename: '2_gran-dillama.ogv', type: 'video/ogg', data: 'Videos/caminandes/2_gran-dillama.ogv' },
                        { filename: '3_llamigos.ogv', type: 'video/ogg', data: 'Videos/caminandes/3_llamigos.ogv' },
                        { filename: '1_llama-drama.png', type: 'image/png', data: 'Videos/caminandes/1_llama-drama.png' },
                        { filename: '2_gran-dillama.png', type: 'image/png', data: 'Videos/caminandes/2_gran-dillama.png' },
                        { filename: '3_llamigos.png', type: 'image/png', data: 'Videos/caminandes/3_llamigos.png' }
                    ] },
                    { filename: 'uebersicht.ods', type: 'application/vnd.oasis.opendocument.spreadsheet', data: 'Videos/uebersicht.ods' }
                ] },
                { filename: 'backups', data: [
                    { filename: 'gescheitert', data: [] }
                ] },
                { filename: '∞_viele_½Sachen…', data: '∞_viele_½Sachen…' }
            ]
        },
        html: 'Erstelle nun eine Kopie der Datei <code>/Videos/trailer.ogv</code> im Ordner <code>/backups</code>, indem du dort den Inhalt der Zwischenablage einfügst.',
        onchange() {
            return !this.check([
                { path: '/Videos/trailer.ogv', data: 'Videos/trailer.ogv' },
                { path: '/backups/trailer.ogv', data: 'Videos/trailer.ogv' }
            ]);
        }
    },
    {
        environment: {
            path: '/backups',
            clipboard: { move: false, path: '/Videos/trailer.ogv' },
            files: [
                { filename: 'Videos', data: [
                    { filename: 'trailer.ogv', type: 'video/ogg', data: 'Videos/trailer.ogv' },
                    { filename: 'Schulprojekt', data: [
                        { filename: 'ideenskizze.txt', type: 'text/plain', data: 'Videos/Schulprojekt/ideenskizze.txt' },
                        { filename: 'aufnahme1.mp4', type: 'video/mp4', data: 'Videos/Schulprojekt/aufnahme1.mp4' }
                    ] },
                    { filename: 'trailer', data: [
                        { filename: 'agent327.ogv', type: 'video/ogg', data: 'Videos/trailer/agent327.ogv' }
                    ] },
                    { filename: 'big_buck_bunny.ogv', type: 'video/ogg', data: 'Videos/big_buck_bunny.ogv' },
                    { filename: 'caminandes', data: [
                        { filename: '1_llama-drama.ogv', type: 'video/ogg', data: 'Videos/caminandes/1_llama-drama.ogv' },
                        { filename: '2_gran-dillama.ogv', type: 'video/ogg', data: 'Videos/caminandes/2_gran-dillama.ogv' },
                        { filename: '3_llamigos.ogv', type: 'video/ogg', data: 'Videos/caminandes/3_llamigos.ogv' },
                        { filename: '1_llama-drama.png', type: 'image/png', data: 'Videos/caminandes/1_llama-drama.png' },
                        { filename: '2_gran-dillama.png', type: 'image/png', data: 'Videos/caminandes/2_gran-dillama.png' },
                        { filename: '3_llamigos.png', type: 'image/png', data: 'Videos/caminandes/3_llamigos.png' }
                    ] },
                    { filename: 'uebersicht.ods', type: 'application/vnd.oasis.opendocument.spreadsheet', data: 'Videos/uebersicht.ods' }
                ] },
                { filename: 'trailer.ogv', type: 'video/ogg', data: '/trailer.ogv' },
                { filename: 'backups', data: [
                    { filename: 'trailer.ogv', type: 'video/ogg', data: 'backups/trailer.ogv' },
                    { filename: 'gescheitert', data: [] }
                ] },
                { filename: '∞_viele_½Sachen…', data: '∞_viele_½Sachen…' }
            ]
        },
        html: 'Mithilfe der Zwischenablage kannst du auch beispielsweise einen Ordner verschieben. Schneide zunächst den Ordner <code>/Videos/Schulprojekt</code> aus.',
        onchange() {
            return (this.clipboard && (this.clipboard == this._root.getByPath('Videos/Schulprojekt')) && this.boolMove);
        }
    },
    {
        environment: {
            path: '/Videos',
            clipboard: { move: true, path: '/Videos/Schulprojekt' },
            files: [
                { filename: 'Videos', data: [
                    { filename: 'trailer.ogv', type: 'video/ogg', data: 'Videos/trailer.ogv' },
                    { filename: 'Schulprojekt', data: [
                        { filename: 'ideenskizze.txt', type: 'text/plain', data: 'Videos/Schulprojekt/ideenskizze.txt' },
                        { filename: 'aufnahme1.mp4', type: 'video/mp4', data: 'Videos/Schulprojekt/aufnahme1.mp4' }
                    ] },
                    { filename: 'trailer', data: [
                        { filename: 'agent327.ogv', type: 'video/ogg', data: 'Videos/trailer/agent327.ogv' }
                    ] },
                    { filename: 'big_buck_bunny.ogv', type: 'video/ogg', data: 'Videos/big_buck_bunny.ogv' },
                    { filename: 'caminandes', data: [
                        { filename: '1_llama-drama.ogv', type: 'video/ogg', data: 'Videos/caminandes/1_llama-drama.ogv' },
                        { filename: '2_gran-dillama.ogv', type: 'video/ogg', data: 'Videos/caminandes/2_gran-dillama.ogv' },
                        { filename: '3_llamigos.ogv', type: 'video/ogg', data: 'Videos/caminandes/3_llamigos.ogv' },
                        { filename: '1_llama-drama.png', type: 'image/png', data: 'Videos/caminandes/1_llama-drama.png' },
                        { filename: '2_gran-dillama.png', type: 'image/png', data: 'Videos/caminandes/2_gran-dillama.png' },
                        { filename: '3_llamigos.png', type: 'image/png', data: 'Videos/caminandes/3_llamigos.png' }
                    ] },
                    { filename: 'uebersicht.ods', type: 'application/vnd.oasis.opendocument.spreadsheet', data: 'Videos/uebersicht.ods' }
                ] },
                { filename: 'trailer.ogv', type: 'video/ogg', data: '/trailer.ogv' },
                { filename: 'backups', data: [
                    { filename: 'trailer.ogv', type: 'video/ogg', data: 'backups/trailer.ogv' },
                    { filename: 'gescheitert', data: [] }
                ] },
                { filename: '∞_viele_½Sachen…', data: '∞_viele_½Sachen…' }
            ]
        },
        html: 'Füge nun den Inhalt der Zwischenablage im Ordner <code>/backups/gescheitert</code> ein.',
        onchange() {
            return this.check([{ path: '/Videos/Schulprojekt' }]) && !this.check([
                { path: '/backups/gescheitert/Schulprojekt/ideenskizze.txt', data: 'Videos/Schulprojekt/ideenskizze.txt' },
                { path: '/backups/gescheitert/Schulprojekt/aufnahme1.mp4', data: 'Videos/Schulprojekt/aufnahme1.mp4' }
            ]);
        }
    },
    {
        environment: {
            path: '/backups/gescheitert',
            files: [
                { filename: 'Videos', data: [
                    { filename: 'trailer.ogv', type: 'video/ogg', data: 'Videos/trailer.ogv' },
                    { filename: 'trailer', data: [
                        { filename: 'agent327.ogv', type: 'video/ogg', data: 'Videos/trailer/agent327.ogv' }
                    ] },
                    { filename: 'big_buck_bunny.ogv', type: 'video/ogg', data: 'Videos/big_buck_bunny.ogv' },
                    { filename: 'caminandes', data: [
                        { filename: '1_llama-drama.ogv', type: 'video/ogg', data: 'Videos/caminandes/1_llama-drama.ogv' },
                        { filename: '2_gran-dillama.ogv', type: 'video/ogg', data: 'Videos/caminandes/2_gran-dillama.ogv' },
                        { filename: '3_llamigos.ogv', type: 'video/ogg', data: 'Videos/caminandes/3_llamigos.ogv' },
                        { filename: '1_llama-drama.png', type: 'image/png', data: 'Videos/caminandes/1_llama-drama.png' },
                        { filename: '2_gran-dillama.png', type: 'image/png', data: 'Videos/caminandes/2_gran-dillama.png' },
                        { filename: '3_llamigos.png', type: 'image/png', data: 'Videos/caminandes/3_llamigos.png' }
                    ] },
                    { filename: 'uebersicht.ods', type: 'application/vnd.oasis.opendocument.spreadsheet', data: 'Videos/uebersicht.ods' }
                ] },
                { filename: 'trailer.ogv', type: 'video/ogg', data: '/trailer.ogv' },
                { filename: 'backups', data: [
                    { filename: 'trailer.ogv', type: 'video/ogg', data: 'backups/trailer.ogv' },
                    { filename: 'gescheitert', data: [
                        { filename: 'Schulprojekt', data: [
                            { filename: 'ideenskizze.txt', type: 'text/plain', data: 'Videos/Schulprojekt/ideenskizze.txt' },
                            { filename: 'aufnahme1.mp4', type: 'video/mp4', data: 'Videos/Schulprojekt/aufnahme1.mp4' }
                        ] }
                    ] }
                ] },
                { filename: '∞_viele_½Sachen…', data: '∞_viele_½Sachen…' }
            ]
        },
        html: 'Dadurch hast du den Ordner <code>Schulprojekt</code> vom Ordner <code>/Videos</code> in den Ordner <code>/backups/gescheitert</code> verschoben. Wechsle nun zurück in den Ordner <code>/Videos</code>, um dich zu überzeugen, dass sich dort kein Ordner namens <code>Schulprojekt</code> mehr befindet.',
        onchange() {
            return (this.path == '/Videos');
        }
    },
    {
        environment: {
            path: '/Videos',
            files: [
                { filename: 'Videos', data: [
                    { filename: 'trailer.ogv', type: 'video/ogg', data: 'Videos/trailer.ogv' },
                    { filename: 'trailer', data: [
                        { filename: 'agent327.ogv', type: 'video/ogg', data: 'Videos/trailer/agent327.ogv' }
                    ] },
                    { filename: 'big_buck_bunny.ogv', type: 'video/ogg', data: 'Videos/big_buck_bunny.ogv' },
                    { filename: 'caminandes', data: [
                        { filename: '1_llama-drama.ogv', type: 'video/ogg', data: 'Videos/caminandes/1_llama-drama.ogv' },
                        { filename: '2_gran-dillama.ogv', type: 'video/ogg', data: 'Videos/caminandes/2_gran-dillama.ogv' },
                        { filename: '3_llamigos.ogv', type: 'video/ogg', data: 'Videos/caminandes/3_llamigos.ogv' },
                        { filename: '1_llama-drama.png', type: 'image/png', data: 'Videos/caminandes/1_llama-drama.png' },
                        { filename: '2_gran-dillama.png', type: 'image/png', data: 'Videos/caminandes/2_gran-dillama.png' },
                        { filename: '3_llamigos.png', type: 'image/png', data: 'Videos/caminandes/3_llamigos.png' }
                    ] },
                    { filename: 'uebersicht.ods', type: 'application/vnd.oasis.opendocument.spreadsheet', data: 'Videos/uebersicht.ods' }
                ] },
                { filename: 'trailer.ogv', type: 'video/ogg', data: '/trailer.ogv' },
                { filename: 'backups', data: [
                    { filename: 'trailer.ogv', type: 'video/ogg', data: 'backups/trailer.ogv' },
                    { filename: 'gescheitert', data: [
                        { filename: 'Schulprojekt', data: [
                            { filename: 'ideenskizze.txt', type: 'text/plain', data: 'Videos/Schulprojekt/ideenskizze.txt' },
                            { filename: 'aufnahme1.mp4', type: 'video/mp4', data: 'Videos/Schulprojekt/aufnahme1.mp4' }
                        ] }
                    ] }
                ] },
                { filename: '∞_viele_½Sachen…', data: '∞_viele_½Sachen…' }
            ]
        },
        html: 'Verstanden? Dann verschiebe nun die Datei <code>/Videos/trailer.ogv</code> in den Ordner <code>/Videos/trailer</code> und benenne sie in <code>big_buck_bunny.ogv</code> um.',
        onchange() {
            return this.check([{ path: '/Videos/trailer.ogv' }]) && !this.check([
                { path: '/Videos/trailer/big_buck_bunny.ogv', data: 'Videos/trailer.ogv' },
                { path: '/backups/gescheitert/Schulprojekt/aufnahme1.mp4', data: 'Videos/Schulprojekt/aufnahme1.mp4' }
            ]);
        }
    },
    {
        environment: {
            path: '/Videos/trailer',
            files: [
                { filename: 'Videos', data: [
                    { filename: 'trailer', data: [
                        { filename: 'big_buck_bunny.ogv', type: 'video/ogg', data: 'Videos/trailer/big_buck_bunny.ogv' },
                        { filename: 'agent327.ogv', type: 'video/ogg', data: 'Videos/trailer/agent327.ogv' }
                    ] },
                    { filename: 'big_buck_bunny.ogv', type: 'video/ogg', data: 'Videos/big_buck_bunny.ogv' },
                    { filename: 'caminandes', data: [
                        { filename: '1_llama-drama.ogv', type: 'video/ogg', data: 'Videos/caminandes/1_llama-drama.ogv' },
                        { filename: '2_gran-dillama.ogv', type: 'video/ogg', data: 'Videos/caminandes/2_gran-dillama.ogv' },
                        { filename: '3_llamigos.ogv', type: 'video/ogg', data: 'Videos/caminandes/3_llamigos.ogv' },
                        { filename: '1_llama-drama.png', type: 'image/png', data: 'Videos/caminandes/1_llama-drama.png' },
                        { filename: '2_gran-dillama.png', type: 'image/png', data: 'Videos/caminandes/2_gran-dillama.png' },
                        { filename: '3_llamigos.png', type: 'image/png', data: 'Videos/caminandes/3_llamigos.png' }
                    ] },
                    { filename: 'uebersicht.ods', type: 'application/vnd.oasis.opendocument.spreadsheet', data: 'Videos/uebersicht.ods' }
                ] },
                { filename: 'trailer.ogv', type: 'video/ogg', data: '/trailer.ogv' },
                { filename: 'backups', data: [
                    { filename: 'trailer.ogv', type: 'video/ogg', data: 'backups/trailer.ogv' },
                    { filename: 'gescheitert', data: [
                        { filename: 'Schulprojekt', data: [
                            { filename: 'ideenskizze.txt', type: 'text/plain', data: 'Videos/Schulprojekt/ideenskizze.txt' },
                            { filename: 'aufnahme1.mp4', type: 'video/mp4', data: 'Videos/Schulprojekt/aufnahme1.mp4' }
                        ] }
                    ] }
                ] },
                { filename: '∞_viele_½Sachen…', data: '∞_viele_½Sachen…' }
            ]
        },
        html: 'Kopieren kann auch sinnvoll sein, wenn du eine Datei als Vorlage verwenden willst: Kopiere die Datei <code>uebersicht.ods</code> vom Ordner <code>/Videos</code> in dessen Unterordner <code>trailer</code>.',
        onchange() {
            return !this.check([
                { path: '/Videos/uebersicht.ods', data: 'Videos/uebersicht.ods' },
                { path: '/Videos/trailer/uebersicht.ods', data: 'Videos/uebersicht.ods' }
            ]);
        }
    }
];

window.FILESYSTEMSETTINGS = {
    useClipboard: true,
    levels: LEVELS
};
